"use strict";

exports.__esModule = true;
exports.NoLabel = exports.Reverse = exports.Disabled = exports.Toggle = exports.Simple = void 0;

var _react = _interopRequireWildcard(require("react"));

var _grommet = require("grommet");

var _themes = require("grommet/themes");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var SimpleCheckBox = function SimpleCheckBox(_ref) {
  var checkedProp = _ref.checked,
      rest = _objectWithoutPropertiesLoose(_ref, ["checked"]);

  var _useState = (0, _react.useState)(!!checkedProp),
      checked = _useState[0],
      setChecked = _useState[1];

  var onChange = function onChange(event) {
    return setChecked(event.target.checked);
  };

  return /*#__PURE__*/_react["default"].createElement(_grommet.Grommet, {
    theme: _themes.grommet
  }, /*#__PURE__*/_react["default"].createElement(_grommet.Box, {
    align: "center",
    pad: "large"
  }, /*#__PURE__*/_react["default"].createElement(_grommet.CheckBox, _extends({}, rest, {
    checked: checked,
    onChange: onChange
  }))));
};

var Simple = function Simple() {
  return /*#__PURE__*/_react["default"].createElement(SimpleCheckBox, {
    label: "Choice"
  });
};

exports.Simple = Simple;

var Toggle = function Toggle() {
  return /*#__PURE__*/_react["default"].createElement(SimpleCheckBox, {
    label: "Choice",
    toggle: true
  });
};

exports.Toggle = Toggle;

var Disabled = function Disabled() {
  return /*#__PURE__*/_react["default"].createElement(SimpleCheckBox, {
    label: "Choice",
    checked: true,
    disabled: true
  });
};

exports.Disabled = Disabled;

var Reverse = function Reverse() {
  return /*#__PURE__*/_react["default"].createElement(SimpleCheckBox, {
    label: "Choice",
    reverse: true
  });
};

exports.Reverse = Reverse;

var NoLabel = function NoLabel() {
  return /*#__PURE__*/_react["default"].createElement(SimpleCheckBox, null);
};

exports.NoLabel = NoLabel;
NoLabel.story = {
  name: 'No label'
};